> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.getunleash.io/llms.txt.
> For full documentation content, see https://docs.getunleash.io/llms-full.txt.

# Get login history

GET https://app.unleash-instance.example.com/api/admin/logins

**Enterprise feature**

Returns **all** login events in the Unleash system. You can optionally get them in CSV format by specifying the `Accept` header as `text/csv`.

Reference: https://docs.getunleash.io/api/get-login-history

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: admin-api
  version: 1.0.0
paths:
  /api/admin/logins:
    get:
      operationId: get-login-history
      summary: Get all login events.
      description: >-
        **Enterprise feature**


        Returns **all** login events in the Unleash system. You can optionally
        get them in CSV format by specifying the `Accept` header as `text/csv`.
      tags:
        - subpackage_instanceAdmin
      parameters:
        - name: Authorization
          in: header
          description: API key needed to access this API
          required: true
          schema:
            type: string
      responses:
        '200':
          description: loginHistorySchema
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/loginHistorySchema'
        '401':
          description: >-
            Authorization information is missing or invalid. Provide a valid API
            token as the `authorization` header, e.g.
            `authorization:*.*.my-admin-token`.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetLoginHistoryRequestUnauthorizedError'
        '404':
          description: The requested resource was not found.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetLoginHistoryRequestNotFoundError'
servers:
  - url: https://app.unleash-instance.example.com
components:
  schemas:
    loginEventSchema:
      type: object
      properties:
        id:
          type: integer
          description: >-
            The event's ID. Event IDs are incrementing integers. In other words,
            a more recent event will always have a higher ID than an older
            event.
        username:
          type: string
          description: >-
            The username of the user that attempted to log in. Will return
            "Incorrectly configured provider" when attempting to log in using a
            misconfigured provider.
        auth_type:
          type: string
          description: The authentication type used to log in.
        created_at:
          type: string
          format: date-time
          description: The date and time of when the login was attempted.
        successful:
          type: boolean
          description: Whether the login was successful or not.
        ip:
          type:
            - string
            - 'null'
          description: The IP address of the client that attempted to log in.
        failure_reason:
          type:
            - string
            - 'null'
          description: >-
            The reason for the login failure. This property is only present if
            the login was unsuccessful.
      required:
        - id
      description: A model representing a single login event.
      title: loginEventSchema
    loginHistorySchema:
      type: object
      properties:
        events:
          type: array
          items:
            $ref: '#/components/schemas/loginEventSchema'
          description: A list of login events
      required:
        - events
      description: A response model with a list of login events.
      title: loginHistorySchema
    GetLoginHistoryRequestUnauthorizedError:
      type: object
      properties:
        id:
          type: string
          description: The ID of the error instance
        name:
          type: string
          description: The name of the error kind
        message:
          type: string
          description: A description of what went wrong.
      title: GetLoginHistoryRequestUnauthorizedError
    GetLoginHistoryRequestNotFoundError:
      type: object
      properties:
        id:
          type: string
          description: The ID of the error instance
        name:
          type: string
          description: The name of the error kind
        message:
          type: string
          description: A description of what went wrong.
      title: GetLoginHistoryRequestNotFoundError
  securitySchemes:
    apiKey:
      type: apiKey
      in: header
      name: Authorization
      description: API key needed to access this API
    bearerToken:
      type: http
      scheme: bearer
      description: API key needed to access this API, in Bearer token format

```

## SDK Code Examples

```python
import requests

url = "https://app.unleash-instance.example.com/api/admin/logins"

headers = {"Authorization": "<apiKey>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://app.unleash-instance.example.com/api/admin/logins';
const options = {method: 'GET', headers: {Authorization: '<apiKey>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://app.unleash-instance.example.com/api/admin/logins"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "<apiKey>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://app.unleash-instance.example.com/api/admin/logins")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = '<apiKey>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://app.unleash-instance.example.com/api/admin/logins")
  .header("Authorization", "<apiKey>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://app.unleash-instance.example.com/api/admin/logins', [
  'headers' => [
    'Authorization' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://app.unleash-instance.example.com/api/admin/logins");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "<apiKey>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "<apiKey>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://app.unleash-instance.example.com/api/admin/logins")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```